
#include "pasmal.check.h"

char tmp[15];

void
mkdate ()
{
  struct tm *lt;
  time_t tt;

  tt = time (0);
  lt = localtime (&tt);
  bzero (tmp, 15);
  sprintf (tmp, "%02d-%02d %02d:%02d:%02d", lt->tm_mon, lt->tm_mday,
	   lt->tm_hour, lt->tm_min, lt->tm_sec);

}


int
main (int argc, char **argv)
{
  char *pasmal_pid;
  char *chk;
  FILE *fp;

  bzero (tmp, 15);

  pasmal_pid = (char *) malloc (255);
  chk = (char *) malloc (255);

  fp = fopen ("/var/run/pasmal.pid", "r");
  if (fp == NULL)
    {
      mkdate ();
      perror ("fopen");
      printf ("*** %s pasmal not running... Running it back.\n", tmp);
      system ("nohup pasmal > /dev/null&");
      free (pasmal_pid);
      return (-1);
    }
  fgets (pasmal_pid, 255, fp);
  fclose (fp);

  pasmal_pid[strlen (pasmal_pid) - 1] = 0;
  printf (":%s:\n", pasmal_pid);

  if (argc == 2 && strlen (argv[1]) > 5)
    {
      printf ("*** refreshing pasmal.\n", tmp);
      system ("nohup pasmal > /dev/null&");
      bzero (chk, 255);
      sprintf (chk, "kill -9 %s\n", pasmal_pid);
      system (chk);
      return 0;
    }

  sprintf (chk, "/proc/%s/cmdline", pasmal_pid);
  fp = fopen (chk, "r");

  if (fp == NULL)
    {
      mkdate ();
      printf ("*** %s pasmal not running... Running it back.\n", tmp);
      system ("nohup pasmal > /dev/null&");
    }
  else
    fclose (fp);

  free (pasmal_pid);
  return (0);

}
