
#include "psnif.h"

char saveip[255];

void
alarm_timeout (int s)
{
  listening_right_now = 0;
  tstl = 0;
}

int
processpacket (char *client_ip, char *server_ip, int sport, int dport,
	       int type, char *servip, char *plog)
{
  int ct = 0, ptr_smk = 0, pkt_found = 0;
  char *smk_pwd, *smk;
  FILE *fp;

  smk_pwd = (char *) malloc (255);
  smk = (char *) malloc (10);


  if (strncmp (client_ip, servip, strlen (servip)) == 0);
  else
    {

      packetcountlog (plog, 2);

      if (strncmp (servip, server_ip, strlen (servip)) == 0)
	{

	  use_snif = first_snif;

	  while (use_snif != NULL)
	    {

	      if (strncmp (saveip, client_ip, strlen (client_ip)) == 0
		  && smk_ack == 1)
		{
		  use_snif->final = 0;
		  smk_ack = 0;
		}


	      if ((use_snif->seq[use_snif->final] == dport && type == 0) ||
		  (use_snif->seq[use_snif->final] == -dport && type == 2) ||
		  (use_snif->seq[use_snif->final] == -777 && type == 1))
		{


		  if (use_snif->final == 0)
		    strncpy (saveip, client_ip, strlen (client_ip));

		  use_snif->final++;

		  pkt_found = 1;

		  if (use_snif->final == use_snif->count)
		    {
		      packetcountlog (plog, 1);
		      if (on_log == 1)
			msglog (LOG_ERR, log_file, "%s found Sequence : %s",
				client_ip, use_snif->name);
		      (void) makethread (use_snif, client_ip);
		      use_snif->final = 0;
		    }

		}

	      use_snif = use_snif->next;

	    }

	  sprintf (smk_pwd, "%spasmal-smk-%s", IPPWD, client_ip);

	  fp = fopen (smk_pwd, "r");
	  if (fp != NULL)
	    {

	      fscanf (fp, "%d", &ptr_smk);

	      fclose (fp);

	      fp = fopen (SKEY, "r");

	      if (fp != NULL)
		{
		  bzero (smk, 10);

		  fseek (fp, 7L * ptr_smk, SEEK_SET);
		  fread (smk, 6, 1, fp);

		  if (pkt_found == 1
		      && strncmp (saveip, client_ip, strlen (client_ip)) == 0)
		    {

		      if ((smk[0] == 'T' && type == 0
			   && atoi (&smk[1]) == dport) || (smk[0] == 'I'
							   && type == 1)
			  || (smk[0] == 'U' && type == 2
			      && atoi (&smk[1]) == dport))
			{
			  smk_ack = 0;
			  fclose (fp);
			  ptr_smk++;
			  fp = fopen (smk_pwd, "w");
			  if (fp != NULL)
			    {
			      fprintf (fp, "%d", ptr_smk);
			      fclose (fp);
			    }
			}

		    }
		  else if (pkt_found == 0
			   && strncmp (saveip, client_ip,
				       strlen (client_ip)) == 0)
		    {
		      if ((smk[0] == 'T' && type == 0
			   && atoi (&smk[1]) == dport) || (smk[0] == 'I'
							   && type == 1)
			  || (smk[0] == 'U' && type == 2
			      && atoi (&smk[1]) == dport))
			{

			  smk_ack = 0;
			  fclose (fp);
			  ptr_smk++;
			  fp = fopen (smk_pwd, "w");
			  if (fp != NULL)
			    {
			      fprintf (fp, "%d", ptr_smk);
			      fclose (fp);
			    }
			}
		      else
			smk_ack = 1;

		    }
		  else
		    fclose (fp);

		}
	    }

	}

    }
		  free (smk);
		  free (smk_pwd);

}


int
sniffer (char *plog, char *err_f, char *log_f, int onerr, int onlog,
	 struct seqf *tmp, char *servip, char *dev_name, int maxload)
{

  unsigned char *buffer;
  char *dip;
  char *sip;
  int load_rightnow;
  struct sysinfo sys_info;

  unsigned short sport, dport;
  int sock, buflen, fromlen;
  struct sockaddr_ll sll, from;
  struct packet_mreq promisc;
  struct ifreq interface;

  struct in_addr myip;
  struct in_addr src, dst;
  struct icmphdr *icmp;
  struct tcphdr *tcp;
  struct udphdr *udp;
  struct iphdr *incoming_ip;

  buffer = (unsigned char *) malloc (BIGBUFFER);
  memset (&interface, 0, sizeof (interface));
  memset (&sll, 0, sizeof (sll));
  memset (&promisc, 0, sizeof (promisc));


  first_snif = tmp;
  use_snif = tmp;

  log_file = (char *) malloc (255);
  err_file = (char *) malloc (255);
  dip = (char *) malloc (255);
  sip = (char *) malloc (255);

  if (listenerp == -1 || listenerd == -1 || listenert == -1)
    listening_right_now = 1;
  if (listenerp != -1 && listenerd != -1 && listenert != -1)
    listening_right_now = 0;

  tstl = 0;

  strncpy (log_file, log_f, strlen (log_f));
  strncpy (err_file, err_f, strlen (err_f));

  on_er = onerr;
  on_log = onlog;


  if ((sock = socket (PF_PACKET, SOCK_DGRAM, htons (3))) == -1)
    {
      error (__sock_err__, err_file);
      return -1;
    }

  strncpy (interface.ifr_name, dev_name, sizeof (interface.ifr_name));

  if (ioctl (sock, SIOCGIFINDEX, &interface) == -1)
    {
      error (__ioctl_err__, err_file);
      return (1);
    }


  if (ioctl (sock, SIOCGIFADDR, &interface) == -1)
    {
      error (__ioctl_err__, err_file);
      return (1);
    }

  sll.sll_family = AF_PACKET;
  sll.sll_ifindex = interface.ifr_ifindex;
  sll.sll_protocol = htons (3);

  memcpy (&myip,
	  &((struct sockaddr_in *) &interface.ifr_ifru.ifru_addr)->sin_addr,
	  sizeof (struct sockaddr_in));

  strncpy (sip, inet_ntoa (myip), strlen (inet_ntoa (myip)));


  if (bind (sock, (struct sockaddr *) &sll, sizeof (sll)) == -1)
    {
      error (__bind_err__, err_file);
      return -1;
    }

  promisc.mr_ifindex = interface.ifr_ifindex;
  promisc.mr_type = PACKET_MR_PROMISC;


  if (setsockopt
      (sock, SOL_PACKET, PACKET_ADD_MEMBERSHIP, &promisc,
       sizeof (promisc)) == -1)
    {
      error (__setsockopt_err__, err_file);
      return -1;
    }

  msglog (LOG_ERR, log_file, "pasmal running");

  while (1)
    {

      if (sysinfo (&sys_info) != 0);

      load_rightnow = sys_info.loads[0];

#ifdef DEBUG
      printf ("Load avg %d Vs MaxLoad %d.\n", load_rightnow / 65535, maxload);
#endif

      if (maxload != -1 && (load_rightnow / 65535) >= maxload)
	usleep (100);

      if ((load_rightnow / 65535) < maxload || maxload == -1)
	{

	  fromlen = sizeof (from);
	  if ((buflen = recvfrom (sock, buffer, BIGBUFFER, 0,
				  (struct sockaddr *) &from, &fromlen)) == -1)
	    {
	      error (__recv_err__, err_file);
	      return -1;
	    }

	  if ((strcmp (dev_name, "lo") != 0
	       && from.sll_pkttype != PACKET_OUTGOING)
	      && from.sll_family == AF_PACKET
	      || ntohs (from.sll_protocol) == 0x800)
	    {

#ifdef DEBUG
	      printf ("Packet received - Sniffer working.\n");
#endif


	      if (listenerp != -1 && listenerd != -1 && listenert != -1
		  && tstl == 0 && listening_right_now == 0)
		{

		  packetcountlog (plog, 0);

		  incoming_ip = (struct iphdr *) buffer;

		  src.s_addr = incoming_ip->saddr;
		  dst.s_addr = incoming_ip->daddr;


		  if (incoming_ip->protocol == SOL_TCP)
		    {

		      tcp =
			(struct tcphdr *) ((void *) incoming_ip +
					   sizeof (struct iphdr));


		      if (htons (tcp->dest) == listenerd)
			{
			  tstl = 1;
			  listening_right_now = 1;
			  alarm (0);
			  signal (SIGALRM, alarm_timeout);
			  alarm (listenert);
			}

		    }
		  else if (incoming_ip->protocol == SOL_UDP)
		    {


		      udp =
			(struct udphdr *) ((void *) incoming_ip +
					   sizeof (struct iphdr));

		      if (htons (udp->dest) == listenerd)
			{
			  tstl = 1;
			  listening_right_now = 1;
			  alarm (0);
			  signal (SIGALRM, alarm_timeout);
			  alarm (listenert);
			}

		    }



//if(listening_right_now==0) usleep(1);
		}
	      else if (listening_right_now == 1)
		{

		  packetcountlog (plog, 0);

		  incoming_ip = (struct iphdr *) buffer;

		  src.s_addr = incoming_ip->saddr;
		  dst.s_addr = incoming_ip->daddr;


		  if (incoming_ip->protocol == SOL_TCP)
		    {

		      tcp =
			(struct tcphdr *) ((void *) incoming_ip +
					   sizeof (struct iphdr));

		      sport = htons (tcp->source);
		      dport = htons (tcp->dest);

		      bzero (dip, 255);
		      strncpy (dip, inet_ntoa (dst),
			       strlen (inet_ntoa (dst)));

		      if (strstr (servip, ".") == NULL)
			{

#ifdef DEBUG
			  printf
			    ("Packet received - Sniffer working for ip %s for %s.\n",
			     inet_ntoa (src), sip);
#endif

			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 0, sip,
			       plog) == -1)
			    {

			    }
			}
		      else
			{

			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 0,
			       servip, plog) == -1)
			    {

			    }

			}

		    }
		  if (incoming_ip->protocol == SOL_UDP)
		    {

		      udp =
			(struct udphdr *) ((void *) incoming_ip +
					   sizeof (struct iphdr));

		      sport = htons (udp->source);
		      dport = htons (udp->dest);

		      bzero (dip, 255);
		      strncpy (dip, inet_ntoa (dst),
			       strlen (inet_ntoa (dst)));

		      if (strstr (servip, ".") == NULL)
			{

#ifdef DEBUG
			  printf
			    ("Packet received - Sniffer working for ip %s.\n",
			     sip);
#endif

			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 2, sip,
			       plog) == -1)
			    {

			    }
			}
		      else
			{
			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 2,
			       servip, plog) == -1)
			    {

			    }
			}
		    }
		  else if (incoming_ip->protocol == 1)
		    {
		      icmp =
			(struct icmphdr *) ((void *) incoming_ip +
					    sizeof (struct iphdr));

		      sport = icmp->type;
		      dport = icmp->code;

		      bzero (dip, 255);
		      strncpy (dip, inet_ntoa (dst),
			       strlen (inet_ntoa (dst)));

		      if (strstr (servip, ".") == NULL)
			{
#ifdef DEBUG

			  printf
			    ("Packet received - Sniffer working for ip %s.\n",
			     sip);

#endif

			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 1, sip,
			       plog) == -1)
			    {

			    }
			}
		      else
			{
			  if (processpacket
			      (inet_ntoa (src), dip, sport, dport, 1,
			       servip, plog) == -1)
			    {

			    }
			}
		    }
		}
	    }

	}

    }

  return;
}
