#include <syslog.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <netpacket/packet.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/sysinfo.h>
#include <arpa/inet.h>
#include <net/if.h>

#include "errors.h"
#include "seqf.h"

#define BIGBUFFER   4096
#define LOWBUFFER   255
#define SKEY "/etc/smokescreen_key"
#define IPPWD "/var/log/"

//#define DEBUG	

struct seqf *first_snif,*use_snif;
int on_er,on_log,smk_ack=-1;
char *log_file,*err_file;
int listenerp=-1,listenerd=-1,listenert=-1;
int listening_right_now = 0,tstl=-1;

int processpacket(char *client_ip,char *server_ip,int sport,int dport,int type,char *servip,char *plog);
int sniffer(char *pcount, char *err_f,char *log_f,int onerr,int onlog,struct seqf *tmp,char *servip,char *dev_name,int maxload);
void setup_listener(int lp,int lt,int ld);

int resetct(struct seqf *ptr);
int addct(struct seqf *ptr);
void alarm_timeout(int s);
