/*
 *      pasmal configuration module
 *
 */

#include <stdio.h> 
#include <stdlib.h>
#include "errors.h"

int main(int argc,char **argv)
{
char dev[255];
char ip[255];
char buftxt[255];
char maxload[255];
FILE *fp,*pf;

bzero(maxload,255);
bzero(dev,255);
bzero(ip,255);

printf("pasmal Configuration\n********************\n\n");
printf("pasmal is a packet authentification sniffer. From packets sent to the server its running on, it will perform actions such as allowing a user to get in. This is the main use of pasmal.\n\n");
printf("Please let us ask a few questions to make a good configuration file!\n\n");
printf("Device you want to snif (eth0,eth1,...) -(if /dev/eth1, just type eth1)-:\n");
read(0,dev,255);
printf("\nIP of your server (xxx.xxx.xxx.xxx you can see it by ifconfig) :\n");
read(0,ip,255);
printf("\nLoad that can be handled by your server before stopping the pasmal daemons (-1 = no limit) : \n");
read(0,maxload,255);

fp = fopen("/etc/pasmal.conf","w");

if(fp==NULL) {
perror("fopen");
exit(1);
}

pf = fopen("/etc/head.conf.tmp","r");

if(pf==NULL) {
perror("fopen");
exit(1);
}

while(!feof(pf)) {

fgets(buftxt,255,pf);
fprintf(fp,"%s",buftxt);

}

fclose(pf);

dev[strlen(dev)-1]=0;
ip[strlen(ip)-1]=0;
maxload[strlen(maxload)-1]=0;

bzero(buftxt,255);
sprintf(buftxt,"DEV=%s;\n\n#\n# IP OF YOUR SERVER\n#\n\nIP=%s;\n\n#\n# LOAD THAT CAN BE STAND BEFORE STOPPING PASMAL (-1 = NO LIMIT) \n#\n\nMAXLOAD=%s;\n\n",dev,ip,maxload);
fprintf(fp,"%s",buftxt);

pf = fopen("/etc/back.conf.tmp","r");

if(pf==NULL) {
perror("fopen");
exit(1);
}

while(!feof(pf)) {

fgets(buftxt,255,pf);
fprintf(fp,"%s",buftxt);

}

fclose(pf);

fclose(fp);


printf("\npasmal.conf is half configured.. \n");

return 1;
}
